## cppcheck 2.19.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(Cppcheck VERSION 2.19.0 LANGUAGES CXX)

include(cmake/options.cmake)

include(cmake/cxx11.cmake)
use_cxx11()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(GNUInstallDirs)

include(cmake/compilerCheck.cmake)
include(cmake/versions.cmake)
include(cmake/findDependencies.cmake)
include(cmake/compileroptions.cmake)
include(cmake/compilerDefinitions.cmake)
include(cmake/buildFiles.cmake)
if(BUILD_GUI)
    include(cmake/qtCompat.cmake)
endif()
include(cmake/printInfo.cmake)


file(GLOB addons_py "addons/*.py")
file(GLOB addons_json "addons/*.json")
file(GLOB cfgs "cfg/*.cfg")
file(GLOB platforms "platforms/*.xml")

if(LIBXML2_XMLLINT_EXECUTABLE)
    add_custom_target(validateCFG DEPENDS validateCFG-cmd)
    add_custom_command(OUTPUT validateCFG-cmd
            COMMAND ${LIBXML2_XMLLINT_EXECUTABLE} --noout ${CMAKE_SOURCE_DIR}/cfg/cppcheck-cfg.rng)
    foreach(cfg ${cfgs})
        add_custom_command(OUTPUT validateCFG-cmd APPEND
                COMMAND ${LIBXML2_XMLLINT_EXECUTABLE} --noout --relaxng ${CMAKE_SOURCE_DIR}/cfg/cppcheck-cfg.rng ${cfg})
    endforeach()
    # this is a symbolic name for a build rule and not an output file
    set_source_files_properties(validateCFG-cmd PROPERTIES SYMBOLIC "true")

    add_custom_target(validatePlatforms ${LIBXML2_XMLLINT_EXECUTABLE} --noout ${CMAKE_SOURCE_DIR}/platforms/cppcheck-platforms.rng)
    foreach(platform ${platforms})
        get_filename_component(platformname ${platform} NAME_WE)
        add_custom_target(validatePlatforms-${platformname} ${LIBXML2_XMLLINT_EXECUTABLE} --noout --relaxng ${CMAKE_SOURCE_DIR}/platforms/cppcheck-platforms.rng ${platform})
        add_dependencies(validatePlatforms validatePlatforms-${platformname})
    endforeach()

    if(TARGET cppcheck)
        add_custom_target(errorlist-xml $<TARGET_FILE:cppcheck> --errorlist > ${CMAKE_BINARY_DIR}/errorlist.xml
                DEPENDS cppcheck)

        add_custom_target(example-xml $<TARGET_FILE:cppcheck> --xml --enable=all --inconclusive --max-configs=1 ${CMAKE_SOURCE_DIR}/samples 2> ${CMAKE_BINARY_DIR}/example.xml
                DEPENDS cppcheck)
    endif()

    add_custom_target(createXMLExamples DEPENDS errorlist-xml example-xml)

    if(Python_EXECUTABLE)
        add_custom_target(checkCWEEntries ${Python_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/listErrorsWithoutCWE.py -F ${CMAKE_BINARY_DIR}/errorlist.xml
                DEPENDS errorlist-xml)
    endif()

    add_custom_target(validateXML ${LIBXML2_XMLLINT_EXECUTABLE} --noout ${CMAKE_SOURCE_DIR}/cppcheck-errors.rng
            COMMAND ${LIBXML2_XMLLINT_EXECUTABLE} --noout --relaxng ${CMAKE_SOURCE_DIR}/cppcheck-errors.rng ${CMAKE_BINARY_DIR}/errorlist.xml
            COMMAND ${LIBXML2_XMLLINT_EXECUTABLE} --noout --relaxng ${CMAKE_SOURCE_DIR}/cppcheck-errors.rng ${CMAKE_BINARY_DIR}/example.xml
            DEPENDS createXMLExamples
            )

    add_custom_target(validateRules ${LIBXML2_XMLLINT_EXECUTABLE} --noout ${CMAKE_SOURCE_DIR}/rules/*.xml)
endif()

# TODO: add the following Makefile features:
# - "man/cppcheck.1" target
# - "tags" target
# - Cygwin handling
# - MinGW handling

if(BUILD_TESTS)
    enable_testing()
endif()

add_custom_target(copy_cfg ALL
    ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/cfg"
        "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/cfg"
    COMMENT "Copying cfg files to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}")

# TODO: copy *.py and *.json only
add_custom_target(copy_addons ALL
    ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/addons"
        "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/addons"
    COMMENT "Copying addons files to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}")

add_custom_target(remove_unsigned_platforms ALL
        ${CMAKE_COMMAND} -E remove -f
        "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/platforms/unix32-unsigned.xml"
        "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/platforms/unix64-unsigned.xml"
        COMMENT "Removing unsigned platforms files from ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}")

add_custom_target(copy_platforms ALL
    ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/platforms"
    "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/platforms"
    DEPENDS remove_unsigned_platforms
    COMMENT "Copying platforms files to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}")

if(USE_BUNDLED_TINYXML2)
    message(STATUS "Using bundled version of tinyxml2")
    add_subdirectory(externals/tinyxml2)
endif()
add_subdirectory(externals/simplecpp)
add_subdirectory(externals/picojson)
add_subdirectory(lib)   # CppCheck Library
add_subdirectory(frontend)
add_subdirectory(cli)   # Client application
add_subdirectory(test)  # Tests
add_subdirectory(gui)   # Graphical application
add_subdirectory(tools)
add_subdirectory(man)

include(cmake/clang_tidy.cmake)

=== Makefile ===
# This file is generated by dmake, do not edit.

ifndef VERBOSE
    VERBOSE=
endif
# To compile with rules, use 'make HAVE_RULES=yes'
ifndef HAVE_RULES
    HAVE_RULES=
endif

ifndef MATCHCOMPILER
    MATCHCOMPILER=
endif
# use match compiler
ifeq ($(MATCHCOMPILER),yes)
    # Find available Python interpreter
    ifeq ($(PYTHON_INTERPRETER),)
        PYTHON_INTERPRETER := $(shell which python3)
    endif
    ifeq ($(PYTHON_INTERPRETER),)
        PYTHON_INTERPRETER := $(shell which python)
    endif
    ifeq ($(PYTHON_INTERPRETER),)
        $(error Did not find a Python interpreter)
    endif
    ifdef VERIFY
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py --verify)
    else
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py)
    endif
    libcppdir:=build
else ifeq ($(MATCHCOMPILER),)
    libcppdir:=lib
else
    $(error invalid MATCHCOMPILER value '$(MATCHCOMPILER)')
endif

ifndef CPPFLAGS
    CPPFLAGS=
endif

ifdef FILESDIR
    override CPPFLAGS+=-DFILESDIR=\"$(FILESDIR)\"
endif

RDYNAMIC?=-rdynamic
# Set the CPPCHK_GLIBCXX_DEBUG flag. This flag is not used in release Makefiles.
# The _GLIBCXX_DEBUG define doesn't work in Cygwin or other Win32 systems.
ifndef COMSPEC
    ifeq ($(VERBOSE),1)
        $(info COMSPEC not found)
    endif
    ifdef ComSpec
        ifeq ($(VERBOSE),1)
            $(info ComSpec found)
        endif
        #### ComSpec is defined on some WIN32's.
        WINNT=1

        ifeq ($(VERBOSE),1)
            $(info PATH=$(PATH))
        endif

        ifneq (,$(findstring /cygdrive/,$(PATH)))
            ifeq ($(VERBOSE),1)
                $(info /cygdrive/ found in PATH)
            endif
            CYGWIN=1
        endif # CYGWIN
    endif # ComSpec
endif # COMSPEC

ifdef WINNT
    ifeq ($(VERBOSE),1)
        $(info WINNT found)
    endif
    #### Maybe Windows
    ifndef CPPCHK_GLIBCXX_DEBUG
        CPPCHK_GLIBCXX_DEBUG=
    endif # !CPPCHK_GLIBCXX_DEBUG

    ifeq ($(VERBOSE),1)
        $(info MSYSTEM=$(MSYSTEM))
    endif

    ifneq ($(MSYSTEM),MINGW32 MINGW64)
        RDYNAMIC=
    endif

    LDFLAGS+=-lshlwapi
else # !WINNT
    ifeq ($(VERBOSE),1)
        $(info WINNT not found)
    endif

    uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

    ifeq ($(VERBOSE),1)
        $(info uname_S=$(uname_S))
    endif

    ifeq ($(uname_S),Linux)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # Linux

    ifeq ($(uname_S),GNU/kFreeBSD)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # GNU/kFreeBSD

    LDFLAGS+=-pthread

endif # WINNT

ifdef CYGWIN
    ifeq ($(VERBOSE),1)
        $(info CYGWIN found)
    endif

    # Increase stack size for Cygwin builds to avoid segmentation fault in limited recursive tests.
    CXXFLAGS+=-Wl,--stack,8388608
endif # CYGWIN

ifndef CXX
    CXX=g++
endif

ifeq (clang++, $(findstring clang++,$(CXX)))
    CPPCHK_GLIBCXX_DEBUG=
endif
ifndef CXXFLAGS
    CXXFLAGS=-O2 -Wall -Wno-sign-compare -Wno-multichar
endif

override CPPFLAGS += -DNDEBUG

ifeq (g++, $(findstring g++,$(CXX)))
    override CXXFLAGS += -pipe
endif
override CXXFLAGS += -std=c++11
ifeq ($(HAVE_RULES),yes)
    PCRE_CONFIG = $(shell which pcre-config)
    ifeq ($(PCRE_CONFIG),)
        $(error Did not find pcre-config)
    endif
    override CXXFLAGS += $(shell $(PCRE_CONFIG) --cflags)
    override CPPFLAGS += -DHAVE_RULES
    ifdef LIBS
        LIBS += $(shell $(PCRE_CONFIG) --libs)
    else
        LIBS=$(shell $(PCRE_CONFIG) --libs)
    endif
else ifneq ($(HAVE_RULES),)
    $(error invalid HAVE_RULES value '$(HAVE_RULES)')
endif

override CXXFLAGS += $(CXXOPTS)
override CPPFLAGS += $(CPPOPTS)
override LDFLAGS += $(LDOPTS)

ifndef PREFIX
    PREFIX=/usr
endif

ifndef INCLUDE_FOR_LIB
    INCLUDE_FOR_LIB=-Ilib -isystem externals -isystem externals/picojson -isystem externals/simplecpp -isystem externals/tinyxml2
endif

ifndef INCLUDE_FOR_FE
    INCLUDE_FOR_FE=-Ilib
endif

ifndef INCLUDE_FOR_CLI
    INCLUDE_FOR_CLI=-Ilib -Ifrontend -isystem externals/picojson -isystem externals/simplecpp -isystem externals/tinyxml2
endif

ifndef INCLUDE_FOR_TEST
    INCLUDE_FOR_TEST=-Ilib -Ifrontend -Icli -isystem externals/picojson -isystem externals/simplecpp -isystem externals/tinyxml2
endif

ifndef CFLAGS_FOR_TEST
    CFLAGS_FOR_TEST=-Wno-dollar-in-identifier-extension
endif

BIN=$(DESTDIR)$(PREFIX)/bin

# For 'make man': sudo apt-get install xsltproc docbook-xsl docbook-xml on Linux
DB2MAN?=/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP=xsltproc -''-nonet -''-param man.charmap.use.subset "0"
MAN_SOURCE=man/cppcheck.1.xml


###### Object Files

LIBOBJ =      $(libcppdir)/valueflow.o \
              $(libcppdir)/tokenize.o \
              $(libcppdir)/symboldatabase.o \
              $(libcppdir)/addoninfo.o \
              $(libcppdir)/analyzerinfo.o \
              $(libcppdir)/astutils.o \
              $(libcppdir)/check.o \
              $(libcppdir)/check64bit.o \
              $(libcppdir)/checkassert.o \
              $(libcppdir)/checkautovariables.o \
              $(libcppdir)/checkbool.o \
              $(libcppdir)/checkbufferoverrun.o \
              $(libcppdir)/checkclass.o \
              $(libcppdir)/checkcondition.o \
              $(libcppdir)/checkers.o \
              $(libcppdir)/checkersidmapping.o \
              $(libcppdir)/checkersreport.o \
              $(libcppdir)/checkexceptionsafety.o \
              $(libcppdir)/checkfunctions.o \
              $(libcppdir)/checkinternal.o \
              $(libcppdir)/checkio.o \
              $(libcppdir)/checkleakautovar.o \
              $(libcppdir)/checkmemoryleak.o \
              $(libcppdir)/checknullpointer.o \
              $(libcppdir)/checkother.o \
              $(libcppdir)/checkpostfixoperator.o \
              $(libcppdir)/checksizeof.o \
              $(libcppdir)/checkstl.o \
              $(libcppdir)/checkstring.o \
              $(libcppdir)/checktype.o \
              $(libcppdir)/checkuninitvar.o \
              $(libcppdir)/checkunusedfunctions.o \
              $(libcppdir)/checkunusedvar.o \
              $(libcppdir)/checkvaarg.o \
              $(libcppdir)/clangimport.o \
              $(libcppdir)/color.o \
              $(libcppdir)/cppcheck.o \
              $(libcppdir)/ctu.o \
              $(libcppdir)/errorlogger.o \
              $(libcppdir)/errortypes.o \
              $(libcppdir)/findtoken.o \
              $(libcppdir)/forwardanalyzer.o \
              $(libcppdir)/fwdanalysis.o \
              $(libcppdir)/importproject.o \
              $(libcppdir)/infer.o \
              $(libcppdir)/keywords.o \
              $(libcppdir)/library.o \
              $(libcppdir)/mathlib.o \
              $(libcppdir)/path.o \
              $(libcppdir)/pathanalysis.o \
              $(libcppdir)/pathmatch.o \
              $(libcppdir)/platform.o \
              $(libcppdir)/preprocessor.o \
              $(libcppdir)/programmemory.o \
              $(libcppdir)/regex.o \
              $(libcppdir)/reverseanalyzer.o \
              $(libcppdir)/sarifreport.o \
              $(libcppdir)/settings.o \
              $(libcppdir)/standards.o \
              $(libcppdir)/summaries.o \
              $(libcppdir)/suppressions.o \
              $(libcppdir)/templatesimplifier.o \
              $(libcppdir)/timer.o \
              $(libcppdir)/token.o \
              $(libcppdir)/tokenlist.o \
              $(libcppdir)/utils.o \
              $(libcppdir)/vf_analyzers.o \
              $(libcppdir)/vf_common.o \
              $(libcppdir)/vf_settokenvalue.o \
              $(libcppdir)/vfvalue.o

EXTOBJ =      externals/simplecpp/simplecpp.o \
              externals/tinyxml2/tinyxml2.o

FEOBJ =       frontend/frontend.o

CLIOBJ =      cli/cmdlineparser.o \
              cli/cppcheckexecutor.o \
              cli/executor.o \
              cli/filelister.o \
              cli/main.o \
              cli/processexecutor.o \
              cli/sehwrapper.o \
              cli/signalhandler.o \
              cli/singleexecutor.o \
              cli/stacktrace.o \
              cli/threadexecutor.o

TESTOBJ =     test/fixture.o \
              test/helpers.o \
              test/main.o \
              test/options.o \
              test/test64bit.o \
              test/testanalyzerinformation.o \
              test/testassert.o \
              test/testastutils.o \
              test/testautovariables.o \
              test/testbool.o \
              test/testbufferoverrun.o \
              test/testcharvar.o \
              test/testcheck.o \
              test/testclangimport.o \
              test/testclass.o \
              test/testcmdlineparser.o \
              test/testcolor.o \
              test/testcondition.o \
              test/testconstructors.o \
              test/testcppcheck.o \
              test/testerrorlogger.o \
              test/testexceptionsafety.o \
              test/testexecutor.o \
              test/testfilelister.o \
              test/testfilesettings.o \
              test/testfrontend.o \
              test/testfunctions.o \
              test/testgarbage.o \
              test/testimportproject.o \
              test/testincompletestatement.o \
              test/testinternal.o \
              test/testio.o \
              test/testleakautovar.o \
              test/testlibrary.o \
              test/testmathlib.o \
              test/testmemleak.o \
              test/testnullpointer.o \
              test/testoptions.o \
              test/testother.o \
              test/testpath.o \
              test/testpathmatch.o \
              test/testplatform.o \
              test/testpostfixoperator.o \
              test/testpreprocessor.o \
              test/testprocessexecutor.o \
              test/testprogrammemory.o \
              test/testregex.o \
              test/testsarifreport.o \
              test/testsettings.o \
              test/testsimplifytemplate.o \
              test/testsimplifytokens.o \
              test/testsimplifytypedef.o \
              test/testsimplifyusing.o \
              test/testsingleexecutor.o \
              test/testsizeof.o \
              test/teststandards.o \
              test/teststl.o \
              test/teststring.o \
              test/testsummaries.o \
              test/testsuppressions.o \
              test/testsymboldatabase.o \
              test/testthreadexecutor.o \
              test/testtimer.o \
              test/testtoken.o \
              test/testtokenize.o \
              test/testtokenlist.o \
              test/testtokenrange.o \
              test/testtype.o \
              test/testuninitvar.o \
              test/testunusedfunctions.o \
              test/testunusedprivfunc.o \
              test/testunusedvar.o \
              test/testutils.o \
              test/testvaarg.o \
              test/testvalueflow.o \
              test/testvarid.o \
              test/testvfvalue.o

.PHONY: run-dmake tags


###### Targets

cppcheck: $(EXTOBJ) $(LIBOBJ) $(FEOBJ) $(CLIOBJ)
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

all:	cppcheck testrunner

testrunner: $(EXTOBJ) $(TESTOBJ) $(LIBOBJ) $(FEOBJ) cli/cmdlineparser.o cli/cppcheckexecutor.o cli/executor.o cli/filelister.o cli/processexecutor.o cli/sehwrapper.o cli/signalhandler.o cli/singleexecutor.o cli/stacktrace.o cli/threadexecutor.o
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

test:	all
	./testrunner

check:	all
	./testrunner -q

checkcfg:	cppcheck validateCFG
	./test/cfg/runtests.sh

dmake:	tools/dmake/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o $(libcppdir)/utils.o externals/simplecpp/simplecpp.o
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)

run-dmake: dmake
	./dmake --release

clean:

=== cli/CMakeLists.txt ===

file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")
file(GLOB mainfile "main.cpp")
list(REMOVE_ITEM srcs ${mainfile})

add_library(cli ${hdrs} ${srcs})
target_include_directories(cli PUBLIC .)
target_link_libraries(cli PRIVATE cppcheck-core frontend tinyxml2 simplecpp picojson)
if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
    target_precompile_headers(cli PRIVATE precompiled.h)
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 13)
    # false positive warning in Clang 13 - caused by FD_ZERO macro
    set_source_files_properties(processexecutor.cpp PROPERTIES COMPILE_FLAGS -Wno-reserved-identifier)
endif()

if (BUILD_CLI)
    list(APPEND cppcheck_SOURCES ${hdrs} ${mainfile})
    if (WIN32)
        list(APPEND cppcheck_SOURCES version.rc)
    endif()

    add_executable(cppcheck ${cppcheck_SOURCES})
    target_link_libraries(cppcheck cppcheck-core cli tinyxml2 simplecpp)
    if (WIN32 AND NOT BORLAND)
        if(NOT MINGW)
            target_link_libraries(cppcheck Shlwapi.lib)
        else()
            target_link_libraries(cppcheck shlwapi)
        endif()
    endif()
    target_link_libraries(cppcheck ${CMAKE_THREAD_LIBS_INIT})

    add_dependencies(cppcheck copy_cfg)
    add_dependencies(cppcheck copy_addons)
    add_dependencies(cppcheck copy_platforms)
    if (NOT DISABLE_DMAKE)
        add_dependencies(cppcheck run-dmake)
    endif()

    install(TARGETS cppcheck
        RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
        COMPONENT applications)

    install(PROGRAMS ${CMAKE_SOURCE_DIR}/htmlreport/cppcheck-htmlreport
        DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
        COMPONENT applications)

    install(FILES ${addons_py}
       DESTINATION ${FILESDIR_DEF}/addons
       COMPONENT headers)

    install(FILES ${addons_json}
       DESTINATION ${FILESDIR_DEF}/addons
       COMPONENT headers)

    install(FILES ${cfgs}
       DESTINATION ${FILESDIR_DEF}/cfg
       COMPONENT headers)

    install(FILES ${platforms}
       DESTINATION ${FILESDIR_DEF}/platforms
       COMPONENT headers)

endif()

=== frontend/CMakeLists.txt ===
file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")

add_library(frontend ${hdrs} ${srcs})
target_include_directories(frontend PUBLIC .)
target_link_libraries(frontend PRIVATE cppcheck-core)

=== gui/CMakeLists.txt ===
if (BUILD_GUI)

    # disable all clang-tidy checks for Qt generated files
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/.clang-tidy"
"---
Checks:          '-*,misc-definitions-in-headers'
WarningsAsErrors: '*'
CheckOptions:
  - { key: HeaderFileExtensions,          value: 'x' }
")

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")
    file(GLOB uis  "*.ui")
    file(GLOB tss  "*.ts")
    QT_WRAP_UI(uis_hdrs ${uis})
    QT_ADD_RESOURCES(resources "gui.qrc")
    # TODO: passing "-no-obsolete" here breaks the translations
    QT_CREATE_TRANSLATION(qms ${CMAKE_CURRENT_SOURCE_DIR} ${tss})
    list(APPEND cppcheck-gui-deps ${hdrs} ${uis_hdrs} ${resources} ${qms})
    add_custom_target(gui-build-deps SOURCES ${cppcheck-gui-deps})

    list(APPEND cppcheck-gui_SOURCES ${srcs})
    if (WIN32)
        list(APPEND cppcheck-gui_SOURCES cppcheck-gui.rc)
    endif()

    add_executable(cppcheck-gui ${cppcheck-gui-deps} ${cppcheck-gui_SOURCES})
    target_link_libraries(cppcheck-gui cppcheck-core simplecpp tinyxml2 picojson frontend)

    set_target_properties(cppcheck-gui PROPERTIES AUTOMOC ON)
    set_target_properties(cppcheck-gui PROPERTIES WIN32_EXECUTABLE ON)
    if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
        target_precompile_headers(cppcheck-gui PRIVATE precompiled.h)
    endif()
    if (HAVE_RULES)
        target_link_libraries(cppcheck-gui ${PCRE_LIBRARY})
    endif()
    target_link_libraries(cppcheck-gui ${QT_CORE_LIB} ${QT_GUI_LIB} ${QT_WIDGETS_LIB} ${QT_PRINTSUPPORT_LIB} ${QT_HELP_LIB} ${QT_NETWORK_LIB})
    if(WITH_QCHART)
        target_link_libraries(cppcheck-gui ${QT_CHARTS_LIB})
    endif()
    if(MSVC)
        # compilation will fail as e.g. QList::realloc would be replaced by MSVC's macro definition
        target_compile_definitions(cppcheck-gui PRIVATE $<$<CONFIG:Debug>:DISABLE_CRTDBG_MAP_ALLOC>)
    endif()
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        if(QT_VERSION VERSION_LESS "6.4.0")
            # caused by Qt generated moc code - see https://bugreports.qt.io/browse/QTBUG-100915
            target_compile_options_safe(cppcheck-gui -Wno-redundant-parens)
        endif()
        if(QT_VERSION VERSION_GREATER_EQUAL "6.9.0")
            # caused by Qt generated moc code starting with 6.9.0 - see https://bugreports.qt.io/browse/QTBUG-135638
            target_compile_options_safe(cppcheck-gui -Wno-ctad-maybe-unsupported)
        endif()
    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        # caused by mocs
        target_compile_options_safe(cppcheck-gui -Wno-useless-cast)
    endif()
    if(QT_VERSION VERSION_GREATER_EQUAL "6.9.2")
        # QBrush fails to compile before 6.9.0 - see https://bugreports.qt.io/browse/QTBUG-134038
        # QtCharts/qxyseries.h fails to compile in 6.9.0 and 6.9.1 - see https://bugreports.qt.io/browse/QTBUG-135637
        #target_compile_definitions(cppcheck-gui PRIVATE -DQT_NO_QPAIR)
    endif()
    target_compile_definitions(cppcheck-gui PRIVATE -DQT_NO_FOREACH)

    target_compile_definitions(cppcheck-gui PRIVATE $<$<NOT:$<CONFIG:Debug>>:QT_NO_DEBUG>)
    target_compile_definitions(cppcheck-gui PRIVATE $<$<NOT:$<CONFIG:Debug>>:QT_NO_DEBUG_OUTPUT>)
    target_compile_definitions(cppcheck-gui PRIVATE $<$<NOT:$<CONFIG:Debug>>:QT_NO_WARNING_OUTPUT>)
    target_compile_definitions(cppcheck-gui PRIVATE $<$<CONFIG:Debug>:QT_DEBUG>)

    if (QHELPGENERATOR)
        # TODO: generate in CMAKE_BINARY_DIR folder
        add_custom_target(online-help.qhc ${QHELPGENERATOR} ${CMAKE_CURRENT_SOURCE_DIR}/help/online-help.qhcp -o ${CMAKE_CURRENT_SOURCE_DIR}/help/online-help.qhc)
        add_dependencies(cppcheck-gui online-help.qhc)
    endif()

    install(TARGETS cppcheck-gui RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)
    install(FILES ${qms} DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)

    install(FILES cppcheck-gui.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

    # icons
    install(FILES cppcheck-gui.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install(FILES cppcheck-gui.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)

    add_dependencies(cppcheck-gui copy_cfg)
    add_dependencies(cppcheck-gui copy_addons)
    add_dependencies(cppcheck-gui copy_platforms)
    if (NOT DISABLE_DMAKE)
        add_dependencies(cppcheck-gui run-dmake)
    endif()

    if (BUILD_TESTS)
        add_subdirectory(test)
    endif()
endif()

=== lib/CMakeLists.txt ===
file(GLOB_RECURSE hdrs "*.h")
file(GLOB_RECURSE srcs "*.cpp")

# move the slowest files to the top
set(srcs_slow "${CMAKE_CURRENT_SOURCE_DIR}/valueflow.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/tokenize.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/symboldatabase.cpp")
list(REMOVE_ITEM srcs ${srcs_slow})
list(INSERT srcs 0 ${srcs_slow})

function(build_src output filename)
    get_filename_component(file ${filename} NAME)
    set(outfile ${CMAKE_CURRENT_BINARY_DIR}/build/mc_${file})
    set(${output} ${${output}} ${outfile} PARENT_SCOPE)
    if (USE_MATCHCOMPILER_OPT STREQUAL "Verify")
        set(verify_option "--verify")
    endif()
    add_custom_command(
        OUTPUT ${outfile}
        COMMAND ${Python_EXECUTABLE} "${PROJECT_SOURCE_DIR}/tools/matchcompiler.py"
                --read-dir="${CMAKE_CURRENT_SOURCE_DIR}" 
                --prefix="mc_" 
                --line 
                ${verify_option} 
                ${file}
        DEPENDS ${file} 
        DEPENDS ${PROJECT_SOURCE_DIR}/tools/matchcompiler.py
    )
    set_source_files_properties(${outfile} PROPERTIES GENERATED TRUE)
endfunction()

if (NOT USE_MATCHCOMPILER_OPT STREQUAL "Off")
    foreach(file ${srcs})
        build_src(srcs_build ${file})
    endforeach()

    set(srcs_lib ${srcs_build})
else()
    set(srcs_lib ${srcs})
endif()

if(BUILD_SHARED_LIBS)
    add_library(cppcheck-core ${srcs_lib} ${hdrs})
else()
    # A OBJECT library is used because the auto-registration doesn't work with static libraries
    add_library(cppcheck-core OBJECT ${srcs_lib} ${hdrs})
endif()
if (BUILD_SHARED_LIBS AND MSVC)
    target_sources(cppcheck-core PRIVATE version.rc)
endif()

target_dll_compile_definitions(cppcheck-core EXPORT CPPCHECKLIB_EXPORT IMPORT CPPCHECKLIB_IMPORT)

target_include_directories(cppcheck-core PUBLIC .)
target_link_libraries(cppcheck-core PRIVATE tinyxml2 simplecpp picojson ${PCRE_LIBRARY})

if (HAVE_RULES)
    target_include_directories(cppcheck-core SYSTEM PRIVATE ${PCRE_INCLUDE})
endif()
if (Boost_FOUND)
    target_include_directories(cppcheck-core SYSTEM PUBLIC ${Boost_INCLUDE_DIRS})
endif()

if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
    target_precompile_headers(cppcheck-core PRIVATE precompiled.h)
endif()

=== oss-fuzz/Makefile ===
# This file is generated by dmake, do not edit.

# make CXX=clang++ MATCHCOMPILER=yes CXXOPTS="-O1 -fno-omit-frame-pointer -gline-tables-only -fsanitize=address -fsanitize-address-use-after-scope" CPPOPTS="-DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION -DHAVE_BOOST" LIB_FUZZING_ENGINE="-fsanitize=fuzzer" oss-fuzz-client

MATCHCOMPILER=yes
ifndef MATCHCOMPILER
    MATCHCOMPILER=
endif
# use match compiler
ifeq ($(MATCHCOMPILER),yes)
    # Find available Python interpreter
    ifeq ($(PYTHON_INTERPRETER),)
        PYTHON_INTERPRETER := $(shell which python3)
    endif
    ifeq ($(PYTHON_INTERPRETER),)
        PYTHON_INTERPRETER := $(shell which python)
    endif
    ifeq ($(PYTHON_INTERPRETER),)
        $(error Did not find a Python interpreter)
    endif
    ifdef VERIFY
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) ../tools/matchcompiler.py --read-dir ../lib --verify)
    else
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) ../tools/matchcompiler.py --read-dir ../lib)
    endif
    libcppdir:=build
else ifeq ($(MATCHCOMPILER),)
    libcppdir:=lib
else
    $(error invalid MATCHCOMPILER value '$(MATCHCOMPILER)')
endif

INCS=-I../lib -isystem../externals/simplecpp -isystem../externals/tinyxml2 -isystem../externals/picojson

override CXXFLAGS+=-std=c++11 -g -w
override CPPFLAGS+=$(INCS)

override CXXFLAGS += $(CXXOPTS)
override CPPFLAGS += $(CPPOPTS)
override LDFLAGS += $(LDOPTS)

LIBOBJ =      $(libcppdir)/valueflow.o \
              $(libcppdir)/tokenize.o \
              $(libcppdir)/symboldatabase.o \
              $(libcppdir)/addoninfo.o \
              $(libcppdir)/analyzerinfo.o \
              $(libcppdir)/astutils.o \
              $(libcppdir)/check.o \
              $(libcppdir)/check64bit.o \
              $(libcppdir)/checkassert.o \
              $(libcppdir)/checkautovariables.o \
              $(libcppdir)/checkbool.o \
              $(libcppdir)/checkbufferoverrun.o \
              $(libcppdir)/checkclass.o \
              $(libcppdir)/checkcondition.o \
              $(libcppdir)/checkers.o \
              $(libcppdir)/checkersidmapping.o \
              $(libcppdir)/checkersreport.o \
              $(libcppdir)/checkexceptionsafety.o \
              $(libcppdir)/checkfunctions.o \
              $(libcppdir)/checkinternal.o \
              $(libcppdir)/checkio.o \
              $(libcppdir)/checkleakautovar.o \
              $(libcppdir)/checkmemoryleak.o \
              $(libcppdir)/checknullpointer.o \
              $(libcppdir)/checkother.o \
              $(libcppdir)/checkpostfixoperator.o \
              $(libcppdir)/checksizeof.o \
              $(libcppdir)/checkstl.o \
              $(libcppdir)/checkstring.o \
              $(libcppdir)/checktype.o \
              $(libcppdir)/checkuninitvar.o \
              $(libcppdir)/checkunusedfunctions.o \
              $(libcppdir)/checkunusedvar.o \
              $(libcppdir)/checkvaarg.o \
              $(libcppdir)/clangimport.o \
              $(libcppdir)/color.o \
              $(libcppdir)/cppcheck.o \
              $(libcppdir)/ctu.o \
              $(libcppdir)/errorlogger.o \
              $(libcppdir)/errortypes.o \
              $(libcppdir)/findtoken.o \
              $(libcppdir)/forwardanalyzer.o \
              $(libcppdir)/fwdanalysis.o \
              $(libcppdir)/importproject.o \
              $(libcppdir)/infer.o \
              $(libcppdir)/keywords.o \
              $(libcppdir)/library.o \
              $(libcppdir)/mathlib.o \
              $(libcppdir)/path.o \
              $(libcppdir)/pathanalysis.o \
              $(libcppdir)/pathmatch.o \
              $(libcppdir)/platform.o \
              $(libcppdir)/preprocessor.o \
              $(libcppdir)/programmemory.o \
              $(libcppdir)/regex.o \
              $(libcppdir)/reverseanalyzer.o \
              $(libcppdir)/sarifreport.o \
              $(libcppdir)/settings.o \
              $(libcppdir)/standards.o \
              $(libcppdir)/summaries.o \
              $(libcppdir)/suppressions.o \
              $(libcppdir)/templatesimplifier.o \
              $(libcppdir)/timer.o \
              $(libcppdir)/token.o \
              $(libcppdir)/tokenlist.o \
              $(libcppdir)/utils.o \
              $(libcppdir)/vf_analyzers.o \
              $(libcppdir)/vf_common.o \
              $(libcppdir)/vf_settokenvalue.o \
              $(libcppdir)/vfvalue.o

EXTOBJ =      simplecpp.o \
              tinyxml2.o

oss-fuzz-client: $(EXTOBJ) $(LIBOBJ) main.o type2.o
	${CXX} ${CXXFLAGS} -o $@ $^ ${LIB_FUZZING_ENGINE}

no-fuzz: $(EXTOBJ) $(LIBOBJ) main_nofuzz.o type2.o
	${CXX} ${CXXFLAGS} -o $@ $^

translate: translate.o type2.o
	${CXX} -std=c++11 -g ${CXXFLAGS} -o $@ type2.cpp translate.cpp

clean:
	rm -f *.o build/*.o oss-fuzz-client no-fuzz translate

preprare-samples:
	rm -rf samples
	mkdir -p samples
	cp -R ../samples .
	find ./samples -type f -name '*.txt' -exec rm -vf {} \;

do-fuzz: oss-fuzz-client preprare-samples
	mkdir -p corpus
	./oss-fuzz-client -only_ascii=1 -timeout=5 -detect_leaks=0 corpus samples ../test/cli/fuzz-crash ../test/cli/fuzz-crash_c ../test/cli/fuzz-timeout

dedup-corpus: oss-fuzz-client preprare-samples
	mv corpus corpus_
	mkdir -p corpus
	./oss-fuzz-client -only_ascii=1 -timeout=5 -detect_leaks=0 corpus corpus_ samples ../test/cli/fuzz-crash ../test/cli/fuzz-crash_c ../test/cli/fuzz-timeout -merge=1

# jobs:
# ./oss-fuzz-client -only_ascii=1 -timeout=5 -detect_leaks=0 corpus samples ../test/cli/fuzz-crash ../test/cli/fuzz-crash_c ../test/cli/fuzz-timeout -workers=12 -jobs=9

# minimize:
# ./oss-fuzz-client -only_ascii=1 -timeout=5 -detect_leaks=0 -minimize_crash=1 crash-0123456789abcdef

simplecpp.o: ../externals/simplecpp/simplecpp.cpp ../externals/simplecpp/simplecpp.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -w -c -o $@ ../externals/simplecpp/simplecpp.cpp

tinyxml2.o: ../externals/tinyxml2/tinyxml2.cpp ../externals/tinyxml2/tinyxml2.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -w -D_LARGEFILE_SOURCE -c -o $@ ../externals/tinyxml2/tinyxml2.cpp

$(libcppdir)/valueflow.o: ../lib/valueflow.cpp ../lib/addoninfo.h ../lib/analyzer.h ../lib/astutils.h ../lib/calculate.h ../lib/check.h ../lib/checkers.h ../lib/checkuninitvar.h ../lib/config.h ../lib/errorlogger.h ../lib/errortypes.h ../lib/findtoken.h ../lib/forwardanalyzer.h ../lib/infer.h ../lib/library.h ../lib/mathlib.h ../lib/path.h ../lib/platform.h ../lib/programmemory.h ../lib/reverseanalyzer.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/timer.h ../lib/token.h ../lib/tokenlist.h ../lib/utils.h ../lib/valueflow.h ../lib/valueptr.h ../lib/vf_analyzers.h ../lib/vf_common.h ../lib/vf_settokenvalue.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/valueflow.cpp

$(libcppdir)/tokenize.o: ../lib/tokenize.cpp ../externals/simplecpp/simplecpp.h ../lib/addoninfo.h ../lib/astutils.h ../lib/checkers.h ../lib/config.h ../lib/errorlogger.h ../lib/errortypes.h ../lib/library.h ../lib/mathlib.h ../lib/path.h ../lib/platform.h ../lib/preprocessor.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/summaries.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/timer.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/valueflow.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/tokenize.cpp

$(libcppdir)/symboldatabase.o: ../lib/symboldatabase.cpp ../lib/addoninfo.h ../lib/astutils.h ../lib/checkers.h ../lib/config.h ../lib/errorlogger.h ../lib/errortypes.h ../lib/keywords.h ../lib/library.h ../lib/mathlib.h ../lib/path.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/valueflow.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/symboldatabase.cpp

$(libcppdir)/addoninfo.o: ../lib/addoninfo.cpp ../externals/picojson/picojson.h ../lib/addoninfo.h ../lib/config.h ../lib/json.h ../lib/path.h ../lib/standards.h ../lib/utils.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/addoninfo.cpp

$(libcppdir)/analyzerinfo.o: ../lib/analyzerinfo.cpp ../externals/tinyxml2/tinyxml2.h ../lib/analyzerinfo.h ../lib/config.h ../lib/errorlogger.h ../lib/errortypes.h ../lib/filesettings.h ../lib/mathlib.h ../lib/path.h ../lib/platform.h ../lib/standards.h ../lib/utils.h ../lib/xml.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/analyzerinfo.cpp

$(libcppdir)/astutils.o: ../lib/astutils.cpp ../lib/addoninfo.h ../lib/astutils.h ../lib/check.h ../lib/checkclass.h ../lib/checkers.h ../lib/config.h ../lib/errortypes.h ../lib/findtoken.h ../lib/infer.h ../lib/library.h ../lib/mathlib.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/token.h ../lib/utils.h ../lib/valueflow.h ../lib/valueptr.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/astutils.cpp

$(libcppdir)/check.o: ../lib/check.cpp ../lib/addoninfo.h ../lib/check.h ../lib/checkers.h ../lib/config.h ../lib/errorlogger.h ../lib/errortypes.h ../lib/library.h ../lib/mathlib.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/standards.h ../lib/templatesimplifier.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/check.cpp

$(libcppdir)/check64bit.o: ../lib/check64bit.cpp ../lib/addoninfo.h ../lib/check.h ../lib/check64bit.h ../lib/checkers.h ../lib/config.h ../lib/errortypes.h ../lib/library.h ../lib/mathlib.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/check64bit.cpp

$(libcppdir)/checkassert.o: ../lib/checkassert.cpp ../lib/addoninfo.h ../lib/astutils.h ../lib/check.h ../lib/checkassert.h ../lib/checkers.h ../lib/config.h ../lib/errortypes.h ../lib/library.h ../lib/mathlib.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/checkassert.cpp

$(libcppdir)/checkautovariables.o: ../lib/checkautovariables.cpp ../lib/addoninfo.h ../lib/astutils.h ../lib/check.h ../lib/checkautovariables.h ../lib/checkers.h ../lib/config.h ../lib/errortypes.h ../lib/library.h ../lib/mathlib.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/valueflow.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/checkautovariables.cpp

$(libcppdir)/checkbool.o: ../lib/checkbool.cpp ../lib/addoninfo.h ../lib/astutils.h ../lib/check.h ../lib/checkbool.h ../lib/checkers.h ../lib/config.h ../lib/errortypes.h ../lib/library.h ../lib/mathlib.h ../lib/platform.h ../lib/settings.h ../lib/smallvector.h ../lib/sourcelocation.h ../lib/standards.h ../lib/symboldatabase.h ../lib/templatesimplifier.h ../lib/token.h ../lib/tokenize.h ../lib/tokenlist.h ../lib/utils.h ../lib/vfvalue.h
	$(CXX) ${LIB_FUZZING_ENGINE} $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $(libcppdir)/checkbool.cpp

=== test/CMakeLists.txt ===
if (BUILD_TESTS)
    add_subdirectory(signal)
    add_subdirectory(seh)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")
    list(APPEND testrunner_SOURCES ${hdrs} ${srcs})

    add_executable(testrunner ${testrunner_SOURCES})
    target_link_libraries(testrunner cppcheck-core tinyxml2 picojson simplecpp frontend cli)
    if (WIN32 AND NOT BORLAND)
        if(NOT MINGW)
            target_link_libraries(testrunner Shlwapi.lib)
        else()
            target_link_libraries(testrunner shlwapi)
        endif()
    endif()
    target_link_libraries(testrunner ${CMAKE_THREAD_LIBS_INIT})
    if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        # (void) in ASSERT_THROW* macros might trigger this
        target_compile_options_safe(testrunner -Wno-useless-cast)
    endif()
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        # $ is used in dinit() designated initialization helper
        target_compile_options_safe(testrunner -Wno-dollar-in-identifier-extension)
    endif()

    if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
        target_precompile_headers(testrunner PRIVATE precompiled.h)
    endif()

    add_dependencies(testrunner copy_cfg)
    add_dependencies(testrunner copy_addons)
    add_dependencies(testrunner copy_platforms)
    if (NOT DISABLE_DMAKE)
        add_dependencies(testrunner run-dmake)
    endif()

    if (LIBXML2_XMLLINT_EXECUTABLE)
        # TODO: run the CMake implementation of the tests
        # TODO: get rid of the copy
        add_custom_target(checkcfg ${CMAKE_COMMAND} -E copy $<TARGET_FILE:cppcheck> ${CMAKE_SOURCE_DIR}
                COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/cfg/runtests.sh
                DEPENDS cppcheck validateCFG)
    endif()

    if (REGISTER_TESTS)
        # CMAKE_MATCH_<n> usage for if (MATCHES) requires CMake 3.9

        find_package(Threads REQUIRED)
        include(ProcessorCount)
        ProcessorCount(N)
        set(CTEST_PARALLEL_LEVEL ${N} CACHE STRING "CTest parallel level")
        # the macos-* runners are sporadically much slower than other runners so chose a high timeout
        set(CTEST_TIMEOUT 130 CACHE STRING "CTest timeout")
        add_custom_target(check ${CMAKE_CTEST_COMMAND} --output-on-failure -j ${CTEST_PARALLEL_LEVEL} -C ${CMAKE_CFG_INTDIR} --timeout ${CTEST_TIMEOUT}
                DEPENDS testrunner cppcheck)

        set(SKIP_TESTS "" CACHE STRING "A list of tests to skip")

        function(add_fixture NAME)
            if (${NAME} IN_LIST SKIP_TESTS)
            elseif(TEST ${NAME})
            else()
                add_test(NAME ${NAME} COMMAND $<TARGET_FILE:testrunner> ${NAME} WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
            endif()
        endfunction()

        foreach(SRC ${srcs})
            file(STRINGS ${SRC} FIXTURE_LINE REGEX "^REGISTER_TEST\\([a-zA-z0-9]+\\)$")
            foreach(_fixture_line ${FIXTURE_LINE})
                if(_fixture_line MATCHES "^REGISTER_TEST\\(([a-zA-z0-9]+)\\)$")
                    add_fixture(${CMAKE_MATCH_1})
                endif()
            endforeach()
        endforeach()

        function(add_cfg CFG_TEST)
            set(oneValueArgs PLATFORM NAME)
            set(multiValueArgs ADD_LIBRARY)

            cmake_parse_arguments(PARSE "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
            get_filename_component(LIBRARY ${CFG_TEST} NAME_WE)
            # TODO: get rid of this
            if(PARSE_ADD_LIBRARY)
                string(REPLACE ";" "," ADD_LIBRARY "${PARSE_ADD_LIBRARY}")
                set(LIBRARY "${ADD_LIBRARY},${LIBRARY}")
            endif()
            set(PLATFORM unix64)
            if(PARSE_PLATFORM)
                set(PLATFORM ${PARSE_PLATFORM})
            endif()
            if(PARSE_NAME)
                set(TEST_NAME ${PARSE_NAME})
            else()
                string(MAKE_C_IDENTIFIER ${CFG_TEST} TEST_NAME)
            endif()
            if ("cfg-${TEST_NAME}" IN_LIST SKIP_TESTS)
            else()
                # TODO: add syntax check
                add_test(NAME cfg-${TEST_NAME}
                        COMMAND $<TARGET_FILE:cppcheck>
                        --library=${LIBRARY}
                        --check-library
                        --check-level=exhaustive
                        --platform=${PLATFORM}
                        --enable=style,information
                        --inconclusive
                        --force
                        --error-exitcode=1
                        --inline-suppr
                        --debug-warnings
                        --suppress=checkersReport
                        ${CMAKE_CURRENT_SOURCE_DIR}/cfg/${CFG_TEST}
                )
            endif()
        endfunction()
        # TODO: glob this
        add_cfg(boost.cpp)
        add_cfg(bsd.c)
        add_cfg(cairo.c)
        add_cfg(cppunit.cpp)
        add_cfg(emscripten.cpp)
        # TODO: posix needs to specified first or it has a different mmap() config
        # TODO: get rid of posix dependency
        add_cfg(gnu.c ADD_LIBRARY posix)
        add_cfg(googletest.cpp)
        add_cfg(gtk.c)
        add_cfg(kde.cpp ADD_LIBRARY qt)
        add_cfg(libcurl.c)
        add_cfg(libsigc++.cpp)
        add_cfg(lua.c)
        add_cfg(mfc.cpp)
        add_cfg(opencv2.cpp)
        add_cfg(openmp.c)
        add_cfg(openssl.c)
        add_cfg(posix.c)
        add_cfg(python.c)
        add_cfg(qt.cpp)
        add_cfg(selinux.c)
        add_cfg(sqlite3.c)
        add_cfg(std.c)
        add_cfg(std.cpp)
        add_cfg(windows.cpp NAME windows32A PLATFORM win32A)
        add_cfg(windows.cpp NAME windows32W PLATFORM win32W)
        add_cfg(windows.cpp NAME windows64 PLATFORM win64)
        add_cfg(wxwidgets.cpp)

        function(fixture_cost NAME COST)
            if(TEST ${NAME})
                set_tests_properties(${NAME} PROPERTIES COST ${COST})
            endif()
        endfunction()

        # Set cost of the more expensive tests to help improve parallel scheduling
        # of tests
        #
        # To collect data to update this list remove "<cmake-build-folder>/Testing/Temporary/CTestCostData.txt",
        # disable the fixture_cost() statements below and run a Debug build with "ctest -j1" several times.
        # Afterwards run it with "ctest -j11" and immediately cancel the run and update the list accordingly to the
        # first eleven tests chosen.
        #
        # NOTE: The TestProcessExecutor* tests are not the slowest but they invoke processes which max out the system
        # and negatively impact the run-time of the other tests
        if (TRUE)
            fixture_cost(TestProcessExecutorFiles 2.00)
            fixture_cost(TestProcessExecutorFS 2.00)
            fixture_cost(TestCondition 1.30)
            fixture_cost(TestStl 1.30)
            fixture_cost(TestTokenizer 1.30)
            fixture_cost(cfg-std_c 1.20)
            fixture_cost(cfg-std_cpp 1.20)
            fixture_cost(TestAutoVariables 1.20)
            fixture_cost(TestUninitVar 1.20)
            fixture_cost(TestSimplifyTemplate 1.15)
            fixture_cost(TestIO 1.15)
            fixture_cost(TestBufferOverrun 1.15)
            fixture_cost(TestClass 1.15)
            fixture_cost(TestNullPointer 1.15)
            fixture_cost(TestSuppressions 1.15)
            fixture_cost(TestLeakAutoVar 1.10)
            fixture_cost(TestSingleExecutorFS 1.10)
            fixture_cost(TestLeakAutoVarRecursiveCountLimit 1.05)
            fixture_cost(TestThreadExecutorFS 1.05)
            fixture_cost(TestThreadExecutorFiles 1.05)
            fixture_cost(TestSymbolDatabase 1.05)
            fixture_cost(TestSingleExecutorFiles 1.05)
            fixture_cost(TestOther 1.05)
            fixture_cost(TestValueFlow 1.05)
            fixture_cost(cfg-wxwidgets_cpp 1.05)
            fixture_cost(cfg-posix_c 1.05)
            fixture_cost(cfg-windows32A 1.03)
            fixture_cost(cfg-windows32W 1.03)
            fixture_cost(cfg-windows64 1.03)
            fixture_cost(TestUnusedVar 1.03)
        endif()
    endif()
endif()

=== externals/picojson/CMakeLists.txt ===

add_library(picojson INTERFACE)
target_externals_include_directories(picojson INTERFACE .)

=== externals/simplecpp/CMakeLists.txt ===
file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")

add_library(simplecpp ${srcs} ${hdrs})
target_dll_compile_definitions(simplecpp EXPORT SIMPLECPP_EXPORT IMPORT SIMPLECPP_IMPORT)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options_safe(simplecpp -Wno-zero-as-null-pointer-constant)
endif()

target_externals_include_directories(simplecpp PUBLIC .)

=== externals/tinyxml2/CMakeLists.txt ===
file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")

add_library(tinyxml2 ${srcs} ${hdrs})
target_dll_compile_definitions(tinyxml2 EXPORT TINYXML2_EXPORT IMPORT TINYXML2_IMPORT)

# TODO: needs to be fixed upstream
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(tinyxml2 PRIVATE -Wno-suggest-attribute=format)
    target_compile_options(tinyxml2 PRIVATE -Wno-useless-cast)
endif()
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options_safe(tinyxml2 -Wno-implicit-fallthrough)
    target_compile_options_safe(tinyxml2 -Wno-suggest-destructor-override)
    target_compile_options_safe(tinyxml2 -Wno-zero-as-null-pointer-constant)
    target_compile_options_safe(tinyxml2 -Wno-format-nonliteral)
    target_compile_options_safe(tinyxml2 -Wno-inconsistent-missing-destructor-override)
endif()
if(CYGWIN)
    target_compile_definitions(-D_LARGEFILE_SOURCE)  # required for fseeko() and ftello()
endif()

target_externals_include_directories(tinyxml2 PUBLIC .)

=== test/signal/CMakeLists.txt ===
add_executable(test-signalhandler
        test-signalhandler.cpp
        ${PROJECT_SOURCE_DIR}/cli/signalhandler.cpp
        ${PROJECT_SOURCE_DIR}/cli/stacktrace.cpp)
target_include_directories(test-signalhandler PRIVATE ${PROJECT_SOURCE_DIR}/cli ${PROJECT_SOURCE_DIR}/lib)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # names for static functions are omitted from trace
    target_compile_options_safe(test-signalhandler -Wno-missing-declarations)
    target_compile_options_safe(test-signalhandler -Wno-missing-prototypes)
    # required for backtrace() to produce function names
    if(NOT CMAKE_SYSTEM_NAME MATCHES AIX)
        target_link_options(test-signalhandler PRIVATE -rdynamic)
    endif()
endif()

add_executable(test-stacktrace
        test-stacktrace.cpp
        ${PROJECT_SOURCE_DIR}/cli/stacktrace.cpp)
target_include_directories(test-stacktrace PRIVATE ${PROJECT_SOURCE_DIR}/cli ${PROJECT_SOURCE_DIR}/lib)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # names for static functions are omitted from trace
    target_compile_options_safe(test-stacktrace -Wno-missing-declarations)
    target_compile_options_safe(test-stacktrace -Wno-missing-prototypes)
    # required for backtrace() to produce function names
    if(NOT CMAKE_SYSTEM_NAME MATCHES AIX)
        target_link_options(test-stacktrace PRIVATE -rdynamic)
    endif()
endif()

=== debian/changelog ===
cppcheck (2.19.0-3) unstable; urgency=medium

  * Adapt patch disable-test-32bit (disable two more tests).
  * Simplify patch disable-test-unsigned-platform.

 -- Joachim Reichel <reichel@debian.org>  Tue, 30 Dec 2025 11:38:43 +0000

cppcheck (2.19.0-2) unstable; urgency=medium

  * Add patch disable-test-32bit.

 -- Joachim Reichel <reichel@debian.org>  Tue, 30 Dec 2025 08:19:29 +0000

cppcheck (2.19.0-1) unstable; urgency=medium

  * New upstream version.
  * Remove patch fix-test-char-signedness (fixed upstream).
  * Add patch disable-test-unsigned-platform.
  * Update Standards-Version to 4.7.3:
    * Remove Priority: field from debian/control.

 -- Joachim Reichel <reichel@debian.org>  Mon, 29 Dec 2025 18:54:13 +0100

=== debian/control ===
Source: cppcheck
Section: devel
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends:
  cmake,
  debhelper-compat (= 13),
  dh-python,
  dh-sequence-python3,
  docbook-xml,
  docbook-xsl,
  libtinyxml2-dev,
  python3-all,
  qt6-base-dev,
  qt6-base-dev-tools,
  qt6-charts-dev,
  qt6-tools-dev,
  xsltproc
Standards-Version: 4.7.3
Rules-Requires-Root: no
Homepage: https://sourceforge.net/p/cppcheck/wiki/Home/
Vcs-Git: https://salsa.debian.org/reichel/cppcheck.git
Vcs-Browser: https://salsa.debian.org/reichel/cppcheck

Package: cppcheck
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-pygments
Suggests: cppcheck-gui, clang, clang-tidy
Description: tool for static C/C++ code analysis (CLI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers;
 .
 This package contains the command-line interface for cppcheck.

Package: cppcheck-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, cppcheck (= ${binary:Version})
Suggests: python3, clang, clang-tidy
Description: tool for static C/C++ code analysis (GUI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers
 .
 This package contains the graphical user interface for cppcheck.
